<script>
import moment from "moment";

export default {
  name: "ProceedingList",
  data () {
    return {
      sorting: "startdate"
    };
  },
  computed: {
    projects () {
      const projectlist = [...this.$store.getters.projectlist].map(project => {
        const link = project.properties.website,
          matches = link.match(/^https?:\/\/(.+?)\./),
          convertedLink = link.replace(new RegExp("/" + matches[1] + "."), "/").replace(/\/#$/, "") + "/" + matches[1] + "/#";

        return {
          name: project.properties.nameFull,
          startdate: moment(project.properties.dateStart),
          link: convertedLink
        };
      });

      return projectlist.sort((a, b) => {
        let compareDetail = [a[this.sorting], b[this.sorting]];

        if (this.sorting === "name") {
          compareDetail = compareDetail.map(item => item.toLowerCase());
        }

        const comparative = compareDetail[0] > compareDetail[1] ? 1 : -1;

        return this.sorting === "startdate" ? comparative * -1 : comparative;
      });
    }
  },
  created () {
    this.$store.dispatch("projectlist");
  },
  methods: {
    setSorting (property) {
      this.sorting = property;
    }
  }
};
</script>

<template>
  <div class="ProceedingList">
    <a
      v-for="(project, index) in projects"
      :key="'project-' + index"
      class="project"
      :class="index % 2 ? 'even' : 'odd'"
      :href="project.link"
      :title="project.name"
      target="_blank"
    >
      <span class="name">
        {{ project.name }}
      </span>
      <span class="icon icon-link" />
    </a>
  </div>
</template>

<style lang="scss">
@import "../../../scss/_global.scss";

div.ProceedingList {
  max-height: 315px;
  padding-bottom: 5px;
  overflow-x: hidden;
  overflow-y: auto;

  a.project {
    display: flex;
    flex-direction: row;
    cursor: pointer;
    text-decoration: none;
    position: relative;

    &.odd {
      background-color: $color_secondary_5;
    }

    &:hover {
      background-color: $color_secondary_4;
    }

    &:focus-visible {
      outline-offset: -3px;
    }

    span {
      display: inline-block;
      white-space: nowrap;
      padding-top: 3px;
      padding-left: 3px;

      &.name {
        font-size: 0.875rem;
        color: $hyperlink;
        overflow: hidden;
        text-overflow: ellipsis;
        flex: 1;
      }

      &.icon {
        position: relative;
        top: 3px;
      }
    }
  }
}

div.wrapper-xs {
  div.ProceedingList {
    a.project {
      max-width: 89vw;
    }
  }
}
</style>
